#!/bin/bash


##################################################################################################
##
## fonctions
##

detection_materiel()
{
	#TODO : améliorer la détection matérielle ...
	echo "Identification materielle en cours..."
	marque=$(lshw -class system |grep -i 'poweredge')
	marque=$?
	if [ $marque = 0 ]
	then
		echo "Materiel Dell detecte"
		return 10
	fi
	
	marque=$(lshw -class system |grep -i 'proliant')
	marque=$?
	if [ $marque = 0 ]
	then
		echo "Materiel HP detecte"
		return 20
	fi	
}

depot_hp()
{
	echo "Récupération de la clé de dépôt"
	recup=$(wget http://${serveur_maj%% *}/gpg/cle_ProLiantSupportPack_8.70.gpg)
	recup=$?
	if [ $recup != 0 ]
	then
		EchoRouge "Problème d'accès miroir"
		return 1
	fi

	echo "Installation de la clé de dépôt"	
	cle=$(apt-key add cle_ProLiantSupportPack_8.70.gpg)
	cle=$?
	if [ $cle != 0 ]
	then
		EchoRouge "Problème d'intégration clé GPG"
		return 1
	fi
	
	echo "Mise en place du dépôt"
	echo 'deb http://'${serveur_maj%% *}'/mirror/downloads.linux.hp.com/SDR/downloads/ProLiantSupportPack/Ubuntu/ lucid/current non-free' > /etc/apt/sources.list.d/hp.list
	
	echo "Mise à jour de la liste des paquets"
	maj=$(apt-get -qq update)
	maj=$?
	if [ $maj != 0 ]
	then
		EchoRouge "Update en erreur"
		return 1
	fi
}

paquets_hp()
{
	modprobe ipmi_si
	modprobe ipmi_devintf
	modprobe ipmi_watchdog

	sed -i '$aipmi_si' /etc/modules
	sed -i '$aimpi_devintf' /etc/modules
	sed -i '$aipmi_watchdog' /etc/modules
	
	apt-eole install hp-health hp-snmp-agents hpsmh hp-smh-templates hpacucli cpqacuxe
	echo "L'interface Web d'HPSMH est accessible via https://$adresse_ip_eth0:2381/"
}


depot_dell()
{
	echo "Récupération de la clé de dépôt"
	recup=$(wget http://${serveur_maj%% *}/gpg/cle_omsa_6.5.gpg)
	recup=$?
	if [ $recup != 0 ]
	then
		EchoRouge "Problème d'accès miroir"
		return 1
	fi
	
	echo "Installation de la clé de dépôt"
	cle=$(apt-key add cle_omsa_6.5.gpg)
	cle=$?
	if [ $cle != 0 ]
	then
		EchoRouge "Problème d'intégration clé GPG"
		return 1
	fi
	
	echo "Mise en place du dépôt"	
	echo 'deb ftp://'${serveur_maj%% *}'/mirror/linux.dell.com/repo/community/deb/latest /' > /etc/apt/sources.list.d/dell.list

	echo "Mise à jour de la liste des paquets"
	maj=$(apt-get -qq update)
	maj=$?
	if [ $maj != 0 ]
	then
		EchoRouge "Update en erreur"
		return 1
	fi
}

paquets_dell()
{
	apt-eole install srvadmin-all
	echo "Démarrage de dataeng"
	service dataeng start
	echo "Démarrage de l'interface Web d'OMSA: accessible via https://$adresse_ip_eth0:1311/"
	service dsm_om_connsvc start
}

##
##################################################################################################




#################################################
## main
installation_materiel()
{
	detection_materiel

	case $? in

		10 )
		## matériel de type Dell
		echo "Matériel Dell détecté" >> $scripts/$fichierEnvoi

		depot=$(depot_dell)
		depot=$?
		if [ $depot != 0 ]
		then
			EchoRouge "Problème de dépôt Dell"
			return 1
		else
			EchoVert "Dépôt Dell OK"
		
			paquets=$(paquets_dell)
			paquets=$?
			if [ $paquets != 0 ]
			then
				EchoRouge "Problème d'installation des paquets"
				return 1
			else
				EchoVert "Paquets de supervision installés"
			fi
			return 0
		fi
		;;

		20 )
		## matériel de type HP
		echo "Matériel HP détecté" >> $scripts/$fichierEnvoi
		depot=$(depot_hp)
		depot=$?
		if [ $depot != 0 ]
		then
			EchoRouge "Problème de dépôt HP"
			return 1
		else
			EchoVert "Dépôt HP OK"
		
			paquets=$(paquets_hp)
			paquets=$?
			if [ $paquets != 0 ]
			then
				EchoRouge "Problème d'installation des paquets"
				return 1
			else
				EchoVert "Paquets de supervision installés"
				return 0
			fi
		fi
		;;

		* )
		## matériel inconnu
		echo "Matériel inconnu" >> $scripts/$fichierEnvoi
		echo "Votre matériel n'a pas identifié comme étant un HP ou un Dell."
		echo "Merci de contacter le PSIN si vous estimez que ce n'est pas normal."
		;;

	esac
}
