#!/bin/bash

##############################################################################
## Applications
##
appli_glpi()
{
	if [ $activer_glpi == 'oui' ]
	then
		echo "Application GLPI active" >> $scripts/$fichierEnvoi
	fi	
}

appli_grr()
{
	if [ $activer_grr == 'oui' ]
	then
		echo "Application GRR active" >> $scripts/$fichierEnvoi
	fi	
}

appli_phpmyadmin()
{
	if [ $activer_phpmyadmin == 'oui' ]
	then
		echo "Application phpMyAdmin active" >> $scripts/$fichierEnvoi
	fi	
}

appli_ocs()
{
	if [ $activer_ocsinventory == 'oui' ]
	then
		echo "Application OCS Inventory active" >> $scripts/$fichierEnvoi
	fi	
}
##############################################################################

##############################################################################
## Informations
##
infos_sys()
{
	echo -e "\nModule: $module_type" >> $scripts/$fichierEnvoi
	echo "Marque: $(dmidecode|grep 'Manufacturer:'|sed -n "1p"|sed 's/.*:\(.*\)/\1/')" >> $scripts/$fichierEnvoi
	echo "Modele: $(dmidecode |grep "Product Name:"|sed -n "1p"|sed 's/.*:\(.*\)/\1/')" >> $scripts/$fichierEnvoi
}
##############################################################################

##############################################################################
## Services
##
srv_apache()
{
	if [ $activer_apache == 'oui' ]
	then
		echo "service Apache actif" >> $scripts/$fichierEnvoi
	fi
}

srv_clamav()
{
	if [ $activer_clam == 'oui' ]
	then
		echo "Antivirus Clamav actif" >> $scripts/$fichierEnvoi
	fi
}
srv_clamav_proxy()
{
	if [ $enable_clamd == 'oui' ]
	then
		echo "Antivirus Clamav actif sur le proxy" >> $scripts/$fichierEnvoi
	fi
}

srv_dhcp()
{
	if [ $activer_dhcp == 'oui' ]
	then
		echo "service DHCP actif" >> $scripts/$fichierEnvoi
	fi
}

srv_kaspersky()
{
	if [ $activer_kav_depot == 'oui' ]
	then
		echo "Dépôt Kaspersky actif" >> $scripts/$fichierEnvoi
	fi
}

srv_mysql()
{
	if [ $activer_mysql == 'oui' ]
	then
		echo "service MySql actif" >> $scripts/$fichierEnvoi
	fi
}

srv_onduleur()
{
	if [ $activer_nut == 'oui' ]
	then
		echo "service Onduleur actif" >> $scripts/$fichierEnvoi
		echo "Nom: $nut_ups_name, Pilote: $nut_ups_driver, Port: $nut_ups_port" >> $scripts/$fichierEnvoi
	fi
}

srv_reseau()
{
	# informations IP
	case "$nombre_interfaces" in
	1)
		echo "Adresse IP: $adresse_ip_eth0" >> $scripts/$fichierEnvoi
		;;
	2)
		echo "Adresse IP: $adresse_ip_eth1" >> $scripts/$fichierEnvoi
		;;
	*)
		# spécificité eSSL traitée par la suite
		;;
	esac
}

srv_sso()
{
	if [ $activer_sso == 'distant' ]
	then
		echo "Authentification CAS active" >> $scripts/$fichierEnvoi
	fi
}

srv_surfauth()
{
	if [ $activer_squid_auth == 'oui' ]
	then
		echo "Mode surf authentifié actif" >> $scripts/$fichierEnvoi
		echo "Controleur ECDL: $nom_serveur_smb / $ip_serveur_smb" >> $scripts/$fichierEnvoi
		echo "Domaine: $nom_domaine_smb" >> $scripts/$fichierEnvoi
	fi
}
##############################################################################


######################################################################################################################
## regroupement de services
##
services_commun()
{
	echo "Un nouveau serveur $nom_machine vient d'être installe sur le site $numero_etab" >> $scripts/$fichierEnvoi
	
	# informations IP
	srv_reseau
	
	# informations systèmes
	infos_sys
	
	# onduleurs
	srv_onduleur
	
	# dépôt Kaspersky
	#srv_kaspersky
	
	# serveur DHCP
	#srv_dhcp
	
	# Antivirus
	srv_clamav
}

services_ecdl()
{
	echo -e "\nVariante: $variante_type" >> $scripts/$fichierEnvoi
	# TODO: services ecdl à surveiller
}

services_esbl()
{
	echo -e "\nVariante: $variante_type" >> $scripts/$fichierEnvoi
	if [ $variante_type == 'Applis_Web' ]
	then
		# LAMP
		srv_apache
		srv_mysql
		
		# cerbere
		srv_sso
		
		# Applications Web
		appli_glpi
		appli_grr
		appli_ocs
		appli_phpmyadmin
	fi
}

services_esml()
{
	echo -e "\nVariante: $variante_type" >> $scripts/$fichierEnvoi
	# TODO: tests sur fonctionnalités implémentées
}

services_essl()
{
	echo -e "\nVariante: $variante_type" >> $scripts/$fichierEnvoi

	case "$variante_type" in
	essl-Morea)
		srv_surfauth
		srv_clamav_proxy
		;;
		
	essl-Internet)
		;;
		
	ppp)
		;;
		
	esac
	
	
	# TODO: infos eth suppl
	# TODO: fichiers de zone
	# TODO: selon variante : ppp, morea ...
}

services_zephir()
{
	echo -e "\nVariante: $variante_type" >> $scripts/$fichierEnvoi
	# TODO: etat sauvegarde locale
	# TODO: etat sauvegarde CSP
}
