#!/usr/bin/perl -w
####################### check_wins_ecdl.pl #######################
# Version : 1.00
# Date : 31 Mars 2012
# rajout log
# Author  : PSIN P.Malossane
#############################################################
#
#Verifie une interrogation wins et recupere le masterbroser
#

use strict;
use Getopt::Long;

# Nagios specific

use lib "/usr/lib/nagios/plugins";
use utils qw(%ERRORS $TIMEOUT);
use Time::HiRes 'time','sleep';
#my %ERRORS=('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'DEPENDENT'=>4);
use POSIX qw(strftime);

# Globals

#recuperation du domaine et du serveur wins dans smb.conf


my $critical=20;
my $warning=15;
my $starttimer;
my $endtimer;
my $message;

#Time out commande ldapsearch 
my $TimeOut=30;
my $datelog = strftime "%d-%m-%Y %H:%M:%S", localtime;
my $heurelog = strftime "%H:%M", localtime;
#my $minute_aleatoire = int(rand(10));

my $ServeurWins ="";
my $ServeurWins1 ="";
my $ServeurWins2 ="";


my $CodeSortie=0;
my $resu;
my $latency = 0;
my $MasterBroser;
my $MasterBroserName;

#recup domaine dans $o_domaine et force les elments recherches
my $domaine=`grep "workgroup =" /etc/samba/smb.conf`;
($resu) = $domaine =~ /workgroup \= (.*)$/;
#print "domaine trouvé ".$resu;
if ( !defined($resu) ) {
        $message="ERREUR RECHERCHE DOMAINE LDAP : Domaine introuvable dans configuration Samba\n";
	print $message;
        $CodeSortie=2;
        exit 2;
}
$domaine=$resu;
#wins support = no
my $serveur_wins=`grep "wins support" /etc/samba/smb.conf`;
if ($serveur_wins =~ /no/) {
        $message="CHECK WINS : Serveur WINS non Actif dans la configuration Samba\n";
	print $message;
        $CodeSortie=2;
        exit 0;
}
$serveur_wins=`grep "wins server =" /etc/samba/smb.conf`;
if ($serveur_wins =~ /\#/) {
        $message="CHECK WINS : Serveur WINS non Actif dans la configuration Samba\n";
	print $message;
        $CodeSortie=2;
        exit 0;
}
($resu) = $serveur_wins =~ /wins server \= (.*) /;
#print "serveur wins ".$resu;
if ( !defined($resu) ) {
        $message="CHECK WINS : Aucun serveur WINS declare dans la configuration Samba\n";
	print $message;
        $CodeSortie=2;
        exit 0;
}
if($resu =~ /1/) {
	$serveur_wins=$resu;
}else{
        $message="CHECK WINS : Aucun serveur WINS declare dans la configuration Samba\n";
	print $message;
        $CodeSortie=0;
        exit 0;
}
if(length($serveur_wins) > 15) {
	my @ServeursWins = split(' ',$serveur_wins);
	$ServeurWins1=$ServeursWins[0];
	$ServeurWins2=$ServeursWins[1];
}else{
	$ServeurWins1=$serveur_wins;
	$ServeurWins2="";
}

my $recup;
my $recupMB;
my $recupMB2;
my $recupMBN;
 $starttimer = time();

eval {
    local $SIG{ALRM} = sub { die "timeout" };
    alarm $TimeOut;
	$recup=`nmblookup -U $ServeurWins1 -R '$domaine' -d 2`;
	if ($recup =~ /positive/ and $recup =~ /$domaine\<00\>/) {
		$ServeurWins=$ServeurWins1;
	}else{
		if($ServeurWins2 ne "") {
			$recup=`nmblookup -U $ServeurWins2 -R '$domaine' -d 2`;
				if ($recup =~ /positive/ and $recup =~ /$domaine\<00\>/) {
					$ServeurWins=$ServeurWins2;
				}
		}
	}
	#$recupMB=`nmblookup -U $serveur_wins -R '$domaine#1B'`;
};
#ecrit_log("ldap=$ldap");

if ($@) {
		$message=" *** INTERROGATION WINS TIMEOUT $TimeOut s ***";
        	my $arr=`/usr/bin/killall -9 nmblookup`;
		print $message;
		exit 2;
}
alarm 0;
$endtimer = time();
$latency = (int(1000 * ($endtimer - $starttimer)) / 1000);


if ($recup =~ /positive/ and $recup =~ /$domaine\<00\>/) {
        #verifi mot cle
       #recup masterbroserdd
	$recupMB=`nmblookup -U $ServeurWins1 -R '$domaine#1B'`;
	if ($recupMB =~ /$domaine\<1b\>/) {
		($MasterBroser) = $recupMB =~ /(.*) $domaine\<1b\>/;
		$recupMBN=`nmblookup -A $MasterBroser`;
		($MasterBroserName) = $recupMBN =~ /(.*) \<00\>/;
		$MasterBroserName =~ s/\s+//g;
	}else{
		$recupMB2=`nmblookup -U $ServeurWins2 -R '$domaine#1B'`;
		if ($recupMB2 =~ /$domaine\<1b\>/) {
			($MasterBroser) = $recupMB2 =~ /(.*) $domaine\<1b\>/;
			$recupMBN=`nmblookup -A $MasterBroser`;
			($MasterBroserName) = $recupMBN =~ /(.*) \<00\>/;
			$MasterBroserName =~ s/\s+//g;
		}else{
			$MasterBroserName = "INCONNU";
			$MasterBroser="";
		}
	}        
        if ($latency > $critical) {
             $message="CHECK WINS $ServeurWins OK ($domaine) mais Temps CRITIQUE  $latency s > $critical s MasterBroser:$MasterBroser ($MasterBroserName) \n";
             $CodeSortie=2;
             #exit $ERRORS{"CRITICAL"};
        }elsif ($latency > $warning) {
             $message="CHECK WINS $ServeurWins OK ($domaine) mais Temps degrade  $latency s > $warning s MasterBroser:$MasterBroser  ($MasterBroserName)\n";
             $CodeSortie=1;
        }else{
             $message="CHECK WINS $ServeurWins OK ($domaine) en $latency s MasterBroser:$MasterBroser  ($MasterBroserName)\n";
             $CodeSortie=0;
             #exit $ERRORS{"OK"};
        }

}else{

        $message="CHECK WINS ($serveur_wins) CRITIQUE Pas de reponse des serveurs\n";
        $CodeSortie=2;
}


print $message;
exit $CodeSortie;
